﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XmlClassifier.DataStructures;
using XmlClassifier.DataStructures.Patterns;
using XmlClassifier.Helpers;

namespace XmlClassifier.Algorithms.Classification
{
	public class Rules
	{
		public static void Classify(List<BasePattern> patterns, ref List<Document> testSet)
		{
			int defaultRuleUsed = 0;
			int majorityClass = 1;
			patterns = patterns.OrderByDescending(elem => Guid.NewGuid()).OrderByDescending(x => x.Size).OrderByDescending(x => x.Support).OrderByDescending(x => x.Confidence).ToList();
			foreach (var document in testSet)
			{
				DebugConsole.SetCursorPosition(0, Console.CursorTop);
				DebugConsole.Write(string.Format("{0,3:0}%", (double)(testSet.IndexOf(document)) * 100 / testSet.Count));

				foreach (var pattern in patterns)
				{
					if (pattern.Matches(document))
					{
						document.ActualClass = pattern.Class;
						break;
					}
				}

				if (!document.ActualClass.HasValue)
				{
					//double mindist = double.MaxValue;
					//foreach (var pattern in patterns)
					//{
					//	pattern.CalculateDistance(document);
					//	if (pattern.Distance < mindist)
					//	{
					//		mindist = pattern.Distance;
					//		document.ActualClass = pattern.Class;
					//	}
					//}
					defaultRuleUsed++;
					document.ActualClass = majorityClass;
				}
			}

			DebugConsole.WriteLine("");
			DebugConsole.WriteLine("Default rule used: " + defaultRuleUsed);
		}
	}
}
