﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;

namespace XmlClassifier.DataStructures.Formats
{
	public static class Zaki
	{
		/// <summary>
		/// Transformacja dokumentów XML z postaci drzew XElement do zapisu Zakiego, np. 1 3 4 -1 4 -1 -1.
		/// </summary>
		/// <param name="tree">Drzewo do transformacji</param>
		/// <param name="dictionary">Słownik przechowujący dodane już nazwy elementów i odpowiadające im kolejne numery</param> 
		/// <returns>Drzewo po transformacjiw postaci Zakiego</returns>
		public static string Transform(XElement tree, Dictionary<string, int> dictionary)
		{
			string result = string.Empty;
			Transform(tree, ref result);
			return result;
		}

		private static void Transform(XElement e, ref string result)
		{
			result += "{" + e.Name.LocalName;
			foreach (var child in e.Elements())
			{
				Transform(child, ref result);
			}
			result += "}";
		}
	}
}
